﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Android.Locations;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Text;
using System.Threading;
using Android.Provider;
using Java.Util;
using System.Collections;


namespace xm_Gps
{
	[Activity (Label = "xm_Gps", MainLauncher = true)]
	public class MainActivity : Activity, ILocationListener,GpsStatus.IListener
	{
		TextView keyong;
		TextView keshi;
		TextView haiba;
		TextView shijian;
		TextView jd;
		TextView wd;
		TextView labstatus;
		private LocationManager lm;
		Location _currentLocation;
		string lp;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);
			InitView ();
		
			lm=(LocationManager)GetSystemService(Context.LocationService);
			if (!lm.IsProviderEnabled(LocationManager.GpsProvider)) {
				Toast.MakeText (this, "Open GPS...", ToastLength.Long).Show ();
				//返回开启GPS导航设置界面
				Intent intent = new Intent(Settings.ActionLocationSourceSettings);   
				StartActivityForResult(intent,0); 

				  

			}

//			Criteria criteriaForLocationService = new Criteria
//			{
//				Accuracy = Accuracy.Fine
//			};
//			IList<string> acceptableLocationProviders = lm.GetProviders(criteriaForLocationService, true);
//
//			if (acceptableLocationProviders.Count>0)//.Any())
//			{
//				lp = acceptableLocationProviders[0];//.First();
//			
//			}
//			else
//			{
//				lp = string.Empty;
//			}
			lm.RequestLocationUpdates (LocationManager.GpsProvider, 0, 0, this);
			lm.AddGpsStatusListener (this);
			//lm.AddGpsStatusListener(this);
		
			//Log.Debug(TAG, "Using " + _locationProvider + ".");
		
		}
		async void run()
		{
//			Address address = await ReverseGeocodeCurrentLocation();
//			DisplayAddress(address);
		}
		void InitView()
		{
			keyong = FindViewById<TextView> (Resource.Id.labkeyong);
			keshi = FindViewById<TextView> (Resource.Id.labkeshi);
			haiba = FindViewById<TextView> (Resource.Id.labhaiba);
			shijian = FindViewById<TextView> (Resource.Id.labtime);
			jd = FindViewById<TextView> (Resource.Id.labjd);
			wd = FindViewById<TextView> (Resource.Id.labwd);
			labstatus = FindViewById<TextView> (Resource.Id.labstatus);
			labstatus.Text = GetString (Resource.String.start);
		}

		public async void OnLocationChanged(Location location) {
			_currentLocation = location;
			if (_currentLocation == null)
			{
			
				keyong.Text = "";
				keshi.Text = "";
				haiba.Text = "";
				shijian.Text = "";
				jd.Text = "";
				wd.Text = "";
			}
			else
			{labstatus.Text = GetString (Resource.String.end);
				jd.Text = string.Format("{0:f6}",  _currentLocation.Longitude);
				wd.Text=string.Format ("{0:f6}",_currentLocation.Latitude);
				//int maxSatellites = lm.GetGpsStatus (null).MaxSatellites;
				//keyong.Text =maxSatellites.ToString();
				GpsStatus gpsStatus = lm.GetGpsStatus(null); // 取当前状态  
				//var it = lm.GetGpsStatus (null).Satellites.Iterator ();//.getSatellites().iterator();//创建一个迭代器保存所有卫星  
				//获取卫星  
				var iterable = gpsStatus.Satellites;  
				//再次转换成Iterator  
				var itrator = iterable.Iterator ();  
				//通过遍历重新整理为ArrayList  
				//ArrayList<GpsSatellite> satelliteList=new ArrayList<GpsSatellite>();   
				int count=0;  
				int usecount = 0;
				int maxSatellites = gpsStatus.MaxSatellites;  
				while (itrator.HasNext && count <= maxSatellites) {    
					count++;   

					GpsSatellite satellite = itrator.Next().JavaCast<GpsSatellite>();
					if (satellite.UsedInFix ())
						usecount++;
					//satellite = itrator.next();   
					//statelliteList.add(satellite);  
				}   
				keshi.Text =count.ToString ();
				keyong.Text = usecount.ToString ();
				haiba.Text = string.Format ("{0:f2}", location.Altitude);
			

//				Address address = await ReverseGeocodeCurrentLocation();
//				DisplayAddress(address);
		}
		}

		public void OnProviderDisabled(string provider) {
			labstatus.Text = "OnProviderDisabled";
		}

		public void OnProviderEnabled(string provider) {
			//labstatus.Text = "OnProviderEnabled";
		}

		public void OnGpsStatusChanged(GpsEvent e)
		{  	GpsStatus gpsStatus = lm.GetGpsStatus (null);
			switch (e) {
			case GpsEvent.FirstFix:
				shijian.Text = string.Format ("{0:f2}", gpsStatus.TimeToFirstFix/1000);
				break;
			case GpsEvent.SatelliteStatus:
				if (gpsStatus != null) {
					var satellites = gpsStatus.Satellites;
					IIterator sat = satellites.Iterator ();
					string lSatellites = null;
					int i = 0;
					int b = 0;
					while (sat.HasNext) {
						i++;
						GpsSatellite satellite = sat.Next ().JavaCast<GpsSatellite> ();
						if (satellite.UsedInFix ())
							b++;
						//					//卫星的方位角，浮点型数据  
						//					System.out.println(satelliteList.get(i).getAzimuth());  
						//					//卫星的高度，浮点型数据  
						//					System.out.println(satelliteList.get(i).getElevation());  
						//					//卫星的伪随机噪声码，整形数据  
						//					System.out.println(satelliteList.get(i).getPrn());  
						//					//卫星的信噪比，浮点型数据  
						//					System.out.println(satelliteList.get(i).getSnr());  
						//					//卫星是否有年历表，布尔型数据  
						//					System.out.println(satelliteList.get(i).hasAlmanac());  
						//					//卫星是否有星历表，布尔型数据  
						//					System.out.println(satelliteList.get(i).hasEphemeris());  
						//					//卫星是否被用于近期的GPS修正计算  
						//					System.out.println(satelliteList.get(i).hasAlmanac()); 
						//Debug.WriteLine(satellite.Prn);
					}
					keshi.Text = i.ToString ();
					keyong.Text = b.ToString ();
				}
				break;
			case GpsEvent.Started:
				break;
			case GpsEvent.Stopped:
				break;
			default :
				break;
			}
		

		
		}  
			


		public void OnStatusChanged(string provider, Availability status, Bundle extras) {

			//GpsStatus gpsStatus = lm.GetGpsStatus(null);

		}

		protected override void OnResume()
		{
			base.OnResume();
			//lm.RequestLocationUpdates("gps", 0, 0, this);

		}

		protected override void OnPause()
		{
			base.OnPause();
			lm.RemoveUpdates(this);
		}

		async Task<Address> ReverseGeocodeCurrentLocation()
		{
			Geocoder geocoder = new Geocoder(this);
			IList<Address> addressList =
				await geocoder.GetFromLocationAsync(_currentLocation.Latitude, _currentLocation.Longitude, 10);

			Address address = addressList [0];//.FirstOrDefault();
			return address;
		}

		void DisplayAddress(Address address)
		{
			if (address != null)
			{
				StringBuilder deviceAddress = new StringBuilder();
				for (int i = 0; i < address.MaxAddressLineIndex; i++)
				{
					deviceAddress.AppendLine(address.GetAddressLine(i));
				}
				// Remove the last comma from the end of the address.
				//	_addressText.Text = deviceAddress.ToString();
				labstatus.Text = deviceAddress.ToString ();
			}
			else
			{
				//_addressText.Text = "Unable to determine the address. Try again in a few minutes.";
			}
		}


	}
}


